## Adaptive Data Algorithm be Mohamed Eltay  https://ieeexplore.ieee.org/abstract/document/9091836/
## You need to have a handwritten database downloaded to your computer
## The IFN/ENIT-databse can be downloaded from http://www.ifnenit.com/
## The IFN/ENIT-database contains material for training and testing of Arabic handwriting recognition software.
## Each word inside the database is supplied with an automatically determined and manually verified ground truth.
########################################################################################
## The AHDB-database can be obtained only by contacting the author, Dr. Somaya Al-Maadeed, via email. http://qufaculty.qu.edu.qa/s_alali/ 
## Each word inside the database is supplied with an automatically determined and manually verified ground truth.
########################################################################################
## 	The size of the lexicon and the number of modeling units
l = len(abc_datasets_paths) 					# The total number of images in the database
n = len(characters_as_unit_counter)				# The total number of characters in the given database
total_chars = len(characters_as_unit)
########################################################################################
## The number of modeling units in each model (character)
## characters_as_unit_counter[c] is the number of occurrences of a specific character in the images 
## characters_as_unit_counter[c] This value can be found in the database documentation. 
## In most cases, any given database will provide detailed statistics about each model in the form of a ground truth file. 
## With the selected database, the number of times a specific character appears in the images is given. 
## character_inv_prob is the inverse probability 1/P_n for each model in the database 
########################################################################################
character_inv_prob = {c:(1 /(characters_as_unit_counter[c] / total_chars))  for c in list(characters_as_unit_counter.keys())}
W = {}
W_normalized = {}
########################################################################################
## W is weight of each word of the lexicon
## W_normalized is the normalized weight of each word of the lexicon
## W = {word: x for prob in character_inv_prob for path in abc_datasets_paths}
########################################################################################
weight_sum = 0.0
for path in abc_datasets_paths:
    label = os.path.basename(path)
########################################################################################
## labels[label]['CharsAsUnit'] is a list of the characters in the image, for example, ['Alif', 'Lam', 'Meem',....]
    W[label] = np.sum([character_inv_prob[model] for model in labels[label]['CharsAsUnit']]) / len(labels[label]['CharsAsUnit']) 
    weight_sum += W[label]
########################################################################################
for label in W:
    W_normalized[label] = W[label] / weight_sum